package hls.support.core.wechat.controllers;

import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import hls.support.core.wechat.dto.EnterpriseAppMember;
import hls.support.core.wechat.service.IAppMemberService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;

import org.springframework.validation.BindingResult;

import java.util.List;

@Controller
@RequestMapping("/enterprise/app")
public class AppMemberController extends BaseController {

    @Autowired
    private IAppMemberService service;


    @RequestMapping(value = "/member/query")
    @ResponseBody
    public ResponseData query(EnterpriseAppMember dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
                              @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext, dto, page, pageSize));
    }

    @RequestMapping(value = "/member/submit")
    @ResponseBody
    public ResponseData update(@RequestBody List<EnterpriseAppMember> dto, BindingResult result, HttpServletRequest request) {
        getValidator().validate(dto, result);
        if (result.hasErrors()) {
            ResponseData responseData = new ResponseData(false);
            responseData.setMessage(getErrorMessage(result, request));
            return responseData;
        }
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/member/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request, @RequestBody List<EnterpriseAppMember> dto) {
        service.batchDelete(dto);
        return new ResponseData();
    }

    //TODO 根据app获取成员的可见性数据

}